//
//     
//
// http://robocraft.ru
//

#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <stdlib.h>

#define CV_PIXEL(type,img,x,y) (((type*)(img->imageData+y*img->widthStep))+x*img->nChannels)

int main(int argc, char* argv[])
{
	IplImage *image = 0, *base = 0, *gray = 0, *dst = 0;

	//     
	char* filename = argc >= 2 ? argv[1] : "Image0.jpg";
	char* base_filename = argc >= 3 ? argv[2] : "800px-Black-body-in-mireds-reversed.png";

	//  
	image = cvLoadImage(filename);
	//   
	base = cvLoadImage(base_filename);

	printf("[i] image: %s \n", filename);
	printf("[i] base: %s \n", base_filename);
	assert( image && base );

	// 
	cvNamedWindow("image");
	cvShowImage("image", image);
	cvNamedWindow("base");
	cvShowImage("base", base);

	//      
	gray = cvCreateImage(cvGetSize(image), IPL_DEPTH_8U, 1);
	//     
	cvConvertImage(image, gray, CV_BGR2GRAY);

	//   (  ) 
	dst = cvCloneImage(image);
	// 
	cvZero(dst);

	cvNamedWindow("gray");
	cvShowImage("gray", gray);

	//    
	// :
	// x 20-760 y 50
	// 255 -> 740

	int bx = 0;
	int by = 50;
	//     
	for( int y=0; y<gray->height; y++ ) {
		uchar* ptr = (uchar*)(gray->imageData + y * gray->widthStep);
		for( int x=0; x<gray->width; x++ ) {
			//     
			bx = (int)(ptr[x]*740./255.+20);
			//  
			CV_PIXEL(uchar, dst, x, y)[0] = CV_PIXEL(uchar, base, bx, by)[0];
			CV_PIXEL(uchar, dst, x, y)[1] = CV_PIXEL(uchar, base, bx, by)[1];
			CV_PIXEL(uchar, dst, x, y)[2] = CV_PIXEL(uchar, base, bx, by)[2];
		}
	}

	//  
	cvNamedWindow("color");
	cvShowImage("color", dst);

	//   
	cvWaitKey(0);

	//  
	cvReleaseImage(&image);
	cvReleaseImage(&base);
	cvReleaseImage(&gray);
	cvReleaseImage(&dst);
	//  
	cvDestroyAllWindows();

	return 0;
}
